/***
    1、此插件适用于单页模式网站，即无刷新;
    2、注意的是插件参数 dUrl 为自己的一级域名，这个是必须得填写的，因为方便于程序的操作*;
    3、a 链接为自己的目录文件的html 或者是 json 数据，如果是json 数据的话，那么必须得在插件参数 callBack 中设置 DOM 插入的内容;
    4、插件参数 goHome 回调为回到首页的操作;
    5、如果需要加入loading 的一些操作，那么你可以找到ajax中 beforeSend 和 success 函数添加你需要的代码;
    6、关于 a 链接的 ajax 配置需要与后端沟通，当然此插件可能在项目中有些不足，可以自行修改，添加你想要的功能代码都是可以的;
***/

$.fn.appPage = function (Obj) {
    // 调用时需要传入的配置参数
    var App = {
        ID         : '#appPage',     // 单页应用监听
        Anchor     : '?#',           // 路由锚点
        Domain     : '',             // 你的默认域名
        Route_path : '',             // 配置文件的URL
        goHome     : function(){
            $(Obj.ID).html( '' ) ;
            $(Obj.ID).find('a').removeClass('Route_Yes');
        }, // 返回按钮操纵的时候网址回到首页要操纵的事件
        callBack : function(data){
            $(Obj.ID).html( data ) ;
        }  // 这里是获取到 ajax 数据之后执行的操作
    };

    // 合并参数
    Obj = $.extend(App, Obj);

    this.each(function () {
        // 1、全局常量
        var THAT = $(this),
            NODE   = THAT.find('a'),                 // A标签实例
            CON    = THAT,                           // 切换的内容
            HREF   = window.location.href,           // 当前页面链接
            URL    = null,                           // 需要跳转的链接地址
            NODE_FH= null,                           // 点击A标签需要调用的函数
            ROUTE  = {};                             // 路由表

        // 当直接用 url 在地址栏上访问的时候处理
        var optionUrl = window.location.href,
            result    = optionUrl.split(Obj.Anchor)[1];
        // 当误操作或直接是首页url的时候
        if (result == '' || result == undefined) {
            window.location.href = Obj.Anchor;
        }
        
        // 2、使用同步AJAX - 获取路由表
        $.ajax({
            type: 'GET',
            url: Obj.Route_path,
            async : false, // 同步
            beforeSend: function () { /*addLoading();*/ },
            // 请求成功
            success: function (data) {
                endLoading();
                ROUTE = eval(data); 
                console.log(ROUTE);
            },
            error: function () { CON.html( '<h1>404</h1>'); }
        });

        // 3、对A标签重新绑定操作事件
        NODE.on('click', function () {
            if (HREF_STATUS == false) return false;
            var _this = $(this);
            // 防止重复加载相同A标签
            if (_this.hasClass('Route_Yes')) return false;
            /*
            if (_this.hasClass('back')) {
                Backoff();
                return false;
            }
            */
            // 获取href值来操作
            var th = _this.attr('href');
            if (th == '' || th == 'javascript:' || th == 'javascript:;' || th == 'javascript:void(0)' || th == 'javascript:void(0);') return false;
            // 是否使用API接收请求，并人工渲染
            var fh = _this.attr('data-fh');
            if (fh != undefined) {
                NODE_FH = fh;
            } else {
                NODE_FH = null;
            }

            //如果是首页链接的话，那么就执行首页操作
            if (th == Obj.Domain) {
                URL = null;
                window.location.href = Obj.Anchor;
            } else {
                if (th != undefined) {
                    document.referrer = window.location.href;
                    getDate(th);
                }
            }
            return false;
        });

        // 4、获取数据和操作获取数据之后 DOM 的内容 , 如果设置的没有相关的页面
        var getDate = function (filePath) {
            // 防止重复请求ajax
            if (URL == filePath) return false;

            THAT.find('a').removeClass('Route_Yes');
            THAT.find('a[href="' + filePath + '"]').addClass('Route_Yes');

            // 监测路由表
            var length = ROUTE.length;
            var urlPath= filePath;
            for(var i=0; i<length; i++){
                if (ROUTE[i].key == filePath) {
                    filePath = ROUTE[i].val;
                    break;
                }
            }

            if (NODE_FH == null) {
                // 根据对应的APP切换模式，加载页面内容
                CON.css('opacity', 0);
                CON.css('margin-left', '-'+$(document).width()+'px');
            }
            
            $.ajax({
                type: 'GET',
                async : false, // 同步
                url: '.' + filePath,
                beforeSend: function () { addLoading(); },
                // 请求成功
                success: function (data) {
                    endLoading();
                    if (NODE_FH == null) {
                        // 地址栏记录操作及不重复请求
                        window.location.href = Obj.Anchor + urlPath;
                        URL = urlPath;
                        Obj.callBack(data);// 加载动画
                        CON.animate({'margin-left':0, 'opacity':0.5}, 600,function(){
                            CON.animate({'opacity':1}, 600);
                        });
                    } else {
                        var fh = NODE_FH+'('+data+')';
                        eval(fh);
                    }
                },
                error: function () { CON.html( '<h1>404</h1>');/*报错*/ }
            });
        }

        /*
        // 5、避免一些误操作得到的url
        var TAIL = HREF.split(Obj.Anchor);
        if (HREF.indexOf(Obj.Anchor) != -1 && TAIL[1] != '/' && TAIL[1] != '') {
            var shang_url = getCookie('jzy_shang_url');
            var result    = TAIL[1];
            if (result != shang_url) {
                setCookie('jzy_shang_url', result, 7200);
                getDate(result);
            }
        }

        // 6、直接地址栏访问的时候做初始化加载
        $(window).hashchange(function () {
            // 当直接用 url 在地址栏上访问的时候处理
            var optionUrl = window.location.href,
                result = optionUrl.split(Obj.Anchor)[1];
            // 当误操作或直接是首页url的时候
            if (optionUrl == Obj.dUrl || result == '' || result == '/' || result == undefined) {
                URL = null;
                Obj.goHome();
            } else {
                getDate(result);
            }
            return false;
        });
        */
        
        var Backoff = function () {
            history.go(-1);
        }


    });
    return this;
}

// 7、启动等待加载动画
function addLoading() {
    var height = $(window).height();
    var width  = $(window).width();
    var mask_html = '<div id="appPage_mask" style="position:absolute;top:0px;filter:alpha(opacity=60);background-color:#333;z-index:99999999999999998;left:0px;opacity:0.6;-moz-opacity:0.6;width:'+width+'px; height:'+height+'px"></div>';
    $('body').append(mask_html);
    var Load_html = '<div id="appPage_mask_load" style="position:fixed;z-index:99999999999999999;top:'+((height/2)-18.5)+'px;left:'+((width/2)-18.5)+'px;"><img style="width:37px" src="public/images/loading.gif"> </div>';
    $('body').append(Load_html);
}

// 8、停止加载动画
function endLoading() {
    setTimeout(function() {
        $('#appPage_mask').stop().animate({
            "opacity": "0"
        }, 400);
        $('#appPage_mask_load').stop().animate({
            "opacity": "0"
        }, 400);
        setTimeout(function() {
            $("#appPage_mask").remove();
            $("#appPage_mask_load").remove();
        }, 500);
    }, 700);   
}

